require "da_funk"
require "posxml_parser"

class Main < Device
  def self.call(json = nil)
    PosxmlInterpreter.new(parse(json), nil, false).start
    true
  end

  def self.parse(json)
    if json && (hash = JSON.parse(json)) && hash["initialize"]
      return hash["initialize"]
    end
    "cw_omni_main.posxml"
  end

  def self.version
    InfinitePay.version
  end
end

class InfinitePay
  class InfinitePayError < StandardError; end

  attr_accessor :amount

  def initialize(amount, api_key = nil)
    @amount = amount
    FileDb.new("./shared/cw_emv_payment.dat")["paAmount"] = data
    if api_key
      @api_key = api_key
    else
      @api_key = DaFunk::ParamsDat.file["infinitepay_api_key"]
    end
  end

  def start
    raise InfinitePayError.new("InfinitePay API Key missing") if api_key.to_s.empty?
    DaFunk::ParamsDat.file["infinitepay_api_key"] = api_key

    data = ("%.2f" % amount).sub(".", "").rjust(12, "0")
    FileDb.new("./shared/cw_emv_payment.dat")["paAmount"] = data
    FileDb.new("./shared/cw_emv_payment.dat")["paValue"]  = data
    PosxmlInterpreter.new("cw_omni_readcard.posxml", nil, false).start
  end
end

